-- Moylen - Well of Eternity (EU)
-- moylen at moylen.eu

local addonTitle, addonTable = ...

local MOYCT = CreateFrame("Frame")
MOYCT.version = GetAddOnMetadata("CompetitionTracker", "Version")
MOYCT.color = {
    WHITE  = "|cffffffff";
    RED    = "|cffff6666";
    GREEN  = "|cff66ff66";
    BLUE   = "|cff9999ff";
    YELLOW = "|cffffff66";
    RESET  = "|r";
}

MOYCT.NAME   = 'MOYCT'
MOYCT.NAMEC  = MOYCT.color["RED"] .. "Competition" .. MOYCT.color["GREEN"] .. "Tracker" .. MOYCT.color["RESET"]
SLASH_MOYCT1 = '/comptrack'
MOYCT.SLASH  = SLASH_MOYCT1
MOYCT.SLASHC = MOYCT.color["YELLOW"] .. MOYCT.SLASH .. MOYCT.color["RESET"]

-- MOYCT.COMPETITION = {"Ufra","Elette","Resurgi","Snippy","Rulf","Ciele","João"};

local MOYCT_TextFrame = CreateFrame("Frame");
MOYCT_TextFrame:ClearAllPoints();
MOYCT_TextFrame:SetHeight(300);
MOYCT_TextFrame:SetWidth(300);
MOYCT_TextFrame:SetScript("OnUpdate", MOYCT_TextFrame_OnUpdate);
MOYCT_TextFrame:SetFrameStrata("DIALOG")
MOYCT_TextFrame:Hide();
MOYCT_TextFrame.text = MOYCT_TextFrame:CreateFontString(nil, "BACKGROUND", "PVPInfoTextFont");
MOYCT_TextFrame.text:SetAllPoints();
-- MOYCT_TextFrame.text:SetFont("Fonts\\skurri.ttf",16,"OUTLINE");
MOYCT_TextFrame.text:SetFont("Fonts\\ARIALN.ttf",16,"OUTLINE");
local MOYCT_AG = MOYCT_TextFrame:CreateAnimationGroup();
MOYCT_AG:SetLooping("NONE")
-- MOYCT_TextFrame:SetPoint("CENTER", 50, 200);
MOYCT_TextFrame:SetPoint("CENTER", 0, 200);

local MOYCT_ONLINE = {}

MOYCTCFG = {}
MOYCTCFG.panel = CreateFrame("Frame", "MOYCT_Config", UIParent)
local mainframe = MOYCTCFG.panel
mainframe:Hide()
mainframe.name = "Competition Tracker"
InterfaceOptions_AddCategory(mainframe)
mainframe.title = mainframe:CreateFontString()
mainframe.title:SetFont("Fonts\\ARIALN.ttf", 16, "")
mainframe.title:SetText(MOYCT.NAMEC .. " - " .. MOYCT.color["RED"] .. "Competition " .. MOYCT.color["GREEN"] .. "Tracker|r v." .. MOYCT.version .. "\n|cff999999by |cffffff66Moylen|r|cff999999 (EU - Well of Eternity)|r")
mainframe.title:SetPoint("TOP", mainframe, "TOP", 0, -10)
mainframe.desc = mainframe:CreateFontString()
mainframe.desc:SetFont("Fonts\\ARIALN.ttf", 16, "")
mainframe.desc:SetText(MOYCT.NAMEC .. " tracks your AH competition")
mainframe.desc:SetPoint("TOPLEFT", mainframe, "TOPLEFT", 10, -80)
mainframe.desc2 = mainframe:CreateFontString()
mainframe.desc2:SetFont("Fonts\\ARIALN.ttf", 12, "")
mainframe.desc2:SetText("Add your competitors to your friend list, then choose below which ones you want to track, and you'll be good to go.")
mainframe.desc2:SetPoint("TOPLEFT", mainframe, "TOPLEFT", 10, -100)

mainframe.USESOUNDONLINE = CreateFrame("CheckButton", "MOYCT_Check1", mainframe, "OptionsCheckButtonTemplate")
_G[mainframe.USESOUNDONLINE:GetName().."Text"]:SetText("Play a sound (PVP Flag Taken) when a competitor comes online")
mainframe.USESOUNDONLINE:SetPoint("TOPLEFT", mainframe.desc2, "TOPLEFT", 0, -20)

mainframe.USESOUNDONLINE:SetScript("OnClick", function()
	COMPETITIONTRACKER_SETTINGS["sound"] = mainframe.USESOUNDONLINE:GetChecked() and 1 or 0
	if COMPETITIONTRACKER_SETTINGS["sound"] == 1 then
		DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC..": Enabling sound when a competitor comes online.")
	else
		DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC..": No sound will be played when a competitor comes online.")
	end
 end)


mainframe.start_y_dropdowns = -100
mainframe.dropdowns_width = 150

mainframe.addcompetitordesc = mainframe:CreateFontString()
mainframe.addcompetitordesc:SetFont("Fonts\\ARIALN.ttf", 16, "")
mainframe.addcompetitordesc:SetText(MOYCT.color["GREEN"].."Friends|r (add competitors):")
mainframe.addcompetitordesc:SetPoint("TOPLEFT", mainframe, "TOPLEFT", 10, mainframe.start_y_dropdowns - 65)
mainframe.addcompetitordropdown = CreateFrame("Frame", "MOYCT_ADDCOMPDEFAULT", mainframe, "UIDropDownMenuTemplate")
mainframe.addcompetitordropdown:SetPoint("TOPLEFT", mainframe, "TOPLEFT", 10, mainframe.start_y_dropdowns - 85)
UIDropDownMenu_SetText(mainframe.addcompetitordropdown, "Pick a friend..")
UIDropDownMenu_SetWidth(mainframe.addcompetitordropdown, mainframe.dropdowns_width)

mainframe.remcompetitordesc = mainframe:CreateFontString()
mainframe.remcompetitordesc:SetFont("Fonts\\ARIALN.ttf", 16, "")
mainframe.remcompetitordesc:SetText(MOYCT.color["RED"].."Competitors|r (remove competitors):")
mainframe.remcompetitordesc:SetPoint("TOPLEFT", mainframe, "TOPLEFT", 310, mainframe.start_y_dropdowns - 65)
mainframe.remcompetitordropdown = CreateFrame("Frame", "MOYCT_REMCOMPDEFAULT", mainframe, "UIDropDownMenuTemplate")
mainframe.remcompetitordropdown:SetPoint("TOPLEFT", mainframe, "TOPLEFT", 310, mainframe.start_y_dropdowns - 85)
UIDropDownMenu_SetText(mainframe.remcompetitordropdown, "Pick a competitor..")
UIDropDownMenu_SetWidth(mainframe.remcompetitordropdown, mainframe.dropdowns_width)

mainframe.currentcompetitors = mainframe:CreateFontString()
mainframe.currentcompetitors:SetFont("Fonts\\ARIALN.ttf", 16, "")
mainframe.currentcompetitors:SetText(MOYCT.color["RED"].."Competitors|r (remove competitors):")
mainframe.currentcompetitors:SetPoint("TOPLEFT", mainframe, "TOPLEFT", 10, mainframe.start_y_dropdowns - 135)
mainframe.currentcompetitors:SetText("|rCurrent "..MOYCT.color["RED"].."Competitors|r:")
mainframe.currentcompetitors:SetSize(600, 300)

local function MOYCT_UpdateCompetitors()
	local str = ""
	local comp_length = table.getn(COMPETITIONTRACKER);
	for j = 1, comp_length, 1 do
		if str:len() > 0 then
			str = str .. ", "
		end
		str = str .. COMPETITIONTRACKER[j]
	end
	mainframe.currentcompetitors:SetText("|rCurrent " .. MOYCT.color["RED"] .. "Competitors|r: " .. str)
	-- DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC .. ": DEBUG: competitors: " .. str)
end

local function MOYCT_TextMessage(message)
	MOYCT_AG:Stop();
	MOYCT_AG.alpha = MOYCT_AG:CreateAnimation("Alpha");
	MOYCT_TextFrame:Hide();
	MOYCT_TextFrame.text:SetText( MOYCT.NAMEC .. ":|n" .. message );
	MOYCT_TextFrame:SetAlpha(1);
	MOYCT_TextFrame:Show();
	MOYCT_AG.alpha:SetFromAlpha(1)
	MOYCT_AG.alpha:SetToAlpha(0)
	MOYCT_AG.alpha:SetStartDelay(1.5)
	MOYCT_AG.alpha:SetDuration(3)
	MOYCT_AG.alpha:SetScript("OnFinished", function(self) MOYCT_TextFrame:Hide() end)
	MOYCT_AG:Play();
end

local function moyct_show_competitors(force_show_all)
	-- DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC .. ": (DEBUG) FRIENDS:")
	local comp_length = table.getn(COMPETITIONTRACKER);
	local numFriends, numFriendsOnline = GetNumFriends();
	local comp_msg     = ""
	local seen_changes = 0
	for i = 1, numFriends, 1 do
        local name, level, class, area, online, status, note = GetFriendInfo(i); 
        for j = 1, comp_length, 1 do
            if name == COMPETITIONTRACKER[j] and online then
				if MOYCT_ONLINE[name] then
					-- DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC .. ": " .. name .. " is " .. MOYCT.color["GREEN"] .. "ONLINE")
					comp_msg = comp_msg .. MOYCT.color["RESET"] .. name .. " is " .. MOYCT.color["GREEN"] .. "ONLINE|n"
				else
					DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC .. ": " .. name .. " has come " .. MOYCT.color["GREEN"] .. "ONLINE")
					comp_msg = comp_msg .. MOYCT.color["RESET"] .. name .. " has come " .. MOYCT.color["GREEN"] .. "ONLINE|n"
					seen_changes = 1
					if COMPETITIONTRACKER_SETTINGS["sound"] == 1 then
						-- PlaySoundFile("Sound\\Spells\\PVPFlagTaken.ogg") -- broken in 8.2.0
						PlaySoundFile(569200) -- same, but works in 8.2.0
					end
				end
				MOYCT_ONLINE[name] = 1
            end
            if name == COMPETITIONTRACKER[j] and not online then
				if MOYCT_ONLINE[name] then
					DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC .. ": " .. name .. " has gone " .. MOYCT.color["RED"] .. "offline")
					comp_msg = comp_msg .. MOYCT.color["RESET"] .. name .. " has gone " .. MOYCT.color["RED"] .. "offline|n"
					seen_changes = 1
				end
				MOYCT_ONLINE[name] = nil
            end
        end
    end
	if force_show_all or seen_changes == 1 then
		if comp_msg:len() > 0 then
			MOYCT_TextMessage(comp_msg)
		else
			MOYCT_TextMessage("No-one online!")
		end
	end
	MOYCT_UpdateCompetitors()
end


local function competitiontracker_slashcommand(input)
	moyct_show_competitors(1)
end

local function mainframe_addcompetitordropdown_initialize(self, level, menuList, arg1)
	local numFriends, numFriendsOnline = GetNumFriends();
	local info = UIDropDownMenu_CreateInfo()
	local initials      = {}
	UIDropDownMenu_SetText(mainframe.addcompetitordropdown, "Pick a friend.. (" .. numFriends .. ")")
	
	if numFriends < 20 then
		-- DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC .. ": DEBUG: for <20 friends")
		local friends_names = {}
		for i = 1, numFriends, 1 do
			local name, flevel, class, area, online, status, note = GetFriendInfo(i);
			friends_names[name] = i
		end
		local sorted_names = {}
		for n in pairs(friends_names) do table.insert(sorted_names, n) end
		table.sort(sorted_names)
		for i = 1, numFriends, 1 do
			local friend_i = sorted_names[i]
			local name, flevel, class, area, online, status, note = GetFriendInfo(friend_i);
			info = UIDropDownMenu_CreateInfo()
			if online then
				info.text = MOYCT.color["GREEN"] .. name .. "|r"
			else
				info.text = MOYCT.color["RED"] .. name .. "|r"
			end
			info.notCheckable = true
			info.value = name
			info.func = function ()
				-- DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC .. ": DEBUG: clicked " .. name)
				table.insert(COMPETITIONTRACKER, name)
				MOYCT_UpdateCompetitors()
			end
			UIDropDownMenu_AddButton(info)
		end

	else
		local only_initials = {}
		for i = 1, numFriends, 1 do
			local name, level, class, area, online, status, note = GetFriendInfo(i);
			local initial = name:sub(1,1)
			only_initials[initial] = i -- in case there is only one with that initial
			-- initials[initial] = 1
			if not initials[initial] then initials[initial] = 1 else initials[initial] = initials[initial] + 1 end
		end
		local a_initials = {}
		local num_initials = {}
		local sorted_initials = {}
		for key,value in pairs(initials) do table.insert(a_initials, key) end
		for key,value in pairs(initials) do table.insert(num_initials, value) end
		local n_initials = table.getn(a_initials)
		for n in pairs(a_initials) do table.insert(sorted_initials, n) end
		table.sort(sorted_initials)
		if (level or 1) == 1 then
			-- DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC .. ": DEBUG: MAIN menuList")
			for i = 1, n_initials, 1 do
				local initials_i = sorted_initials[i]
				info = UIDropDownMenu_CreateInfo()
				if num_initials[initials_i] == 1 then
					local friends_i = only_initials[a_initials[initials_i]]
					local name, flevel, class, area, online, status, note = GetFriendInfo(friends_i);
					if online then
						info.text = MOYCT.color["GREEN"] .. name .. "|r"
					else
						info.text = MOYCT.color["RED"] .. name .. "|r"
					end
					info.arg1 = friends_i
					info.notCheckable = true
					info.value = name
					info.func = function ()
						-- DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC .. ": DEBUG: clicked " .. name)
						table.insert(COMPETITIONTRACKER, name)
						table.sort(COMPETITIONTRACKER)
						MOYCT_UpdateCompetitors()
					end
				else
					info.menuList = i
					info.hasArrow = true
					info.text = a_initials[initials_i] .. "... (" .. num_initials[initials_i] .. ")"
					info.notCheckable = true
					info.value = a_initials[initials_i]
					info.arg1  = a_initials[initials_i]
				end
				UIDropDownMenu_AddButton(info)
			end
		else
			-- DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC .. ": DEBUG: menuList " .. menuList .. " for " .. a_initials[menuList])
			for i = 1, numFriends, 1 do
				local name, flevel, class, area, online, status, note = GetFriendInfo(i);
				local initial = name:sub(1,1)
				if initial == a_initials[menuList] then
					info = UIDropDownMenu_CreateInfo()
					if online then
						info.text = MOYCT.color["GREEN"] .. name .. "|r"
					else
						info.text = MOYCT.color["RED"] .. name .. "|r"
					end
					info.arg1 = i
					info.notCheckable = true
					info.value = name
					info.func = function ()
						-- DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC .. ": DEBUG: clicked " .. name)
						table.insert(COMPETITIONTRACKER, name)
						table.sort(COMPETITIONTRACKER)
						MOYCT_UpdateCompetitors()
					end
					UIDropDownMenu_AddButton(info, level)
				end
			end
		end
	end
end

local function mainframe_remcompetitordropdown_initialize(self, level)
	local comp_length = table.getn(COMPETITIONTRACKER);
	table.sort(COMPETITIONTRACKER)
	UIDropDownMenu_SetText(mainframe.remcompetitordropdown, "Pick a competitor.. (" .. comp_length .. ")")
	local info = UIDropDownMenu_CreateInfo()
	for i = 1, comp_length, 1 do
		local name = COMPETITIONTRACKER[i]
		info = UIDropDownMenu_CreateInfo()
		info.text = name
		info.notCheckable = true
		info.value = name
		info.func = function ()
			-- DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC .. ": DEBUG: clicked " .. name)
			local l_comp_length = table.getn(COMPETITIONTRACKER);
			local l_comp_id = nil
			for j = 1, l_comp_length, 1 do
				if COMPETITIONTRACKER[j] == name then
					l_comp_id = j
				end
			end
			table.remove(COMPETITIONTRACKER, l_comp_id)
			table.sort(COMPETITIONTRACKER)
			MOYCT_UpdateCompetitors()
		end
		UIDropDownMenu_AddButton(info)
	end
end


function addonTable:SetupConfigFrame()
	mainframe.USESOUNDONLINE:SetChecked(COMPETITIONTRACKER_SETTINGS["sound"] == 1 and true or false)
	UIDropDownMenu_Initialize(mainframe.addcompetitordropdown, mainframe_addcompetitordropdown_initialize)
	UIDropDownMenu_Initialize(mainframe.remcompetitordropdown, mainframe_remcompetitordropdown_initialize)
end

local function competitiontracker_onevent(self, real_event, arg1, event, _, _, sourceName, _, _, _, destName, _, _, spellId, spellName, spellSchool, amount, overhealing, absorbed, critical)
	if real_event == "ADDON_LOADED" then
		if arg1 == addonTitle then -- this addon
			DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC.." ADDON_LOADED")
			if COMPETITIONTRACKER == nil then
				COMPETITIONTRACKER = {}
				-- COMPETITIONTRACKER = {"Ufra","Elette","Resurgi","Snippy","Rulf","Ciele","João"}
				-- DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC .. ": DEBUG: reset COMPETITIONTRACKER var")
				MOYCT_UpdateCompetitors()
			else
				-- DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC .. ": DEBUG: COMPETITIONTRACKER var was already set")
				MOYCT_UpdateCompetitors()
			end
            if COMPETITIONTRACKER_SETTINGS == nil then
                COMPETITIONTRACKER_SETTINGS = {}
            end
            if COMPETITIONTRACKER_SETTINGS["sound"] == nil then
                COMPETITIONTRACKER_SETTINGS["sound"] = 0
            end
		end
	elseif real_event == "VARIABLES_LOADED" then
		-- DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC.." VARIABLES_LOADED")
		addonTable:SetupConfigFrame()
	elseif real_event == "FRIENDLIST_UPDATE" then
		-- DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC.." FRIENDLIST_UPDATE")
		moyct_show_competitors()
	end
end

MOYCT:SetScript("OnEvent", competitiontracker_onevent)
MOYCT:RegisterEvent("ADDON_LOADED")
MOYCT:RegisterEvent("VARIABLES_LOADED")
MOYCT:RegisterEvent("FRIENDLIST_UPDATE")

SlashCmdList["MOYCT"] = competitiontracker_slashcommand

DEFAULT_CHAT_FRAME:AddMessage(MOYCT.NAMEC.." v"..MOYCT.version.." loaded. type "..MOYCT.SLASHC.." to configure, or see the interface panel.")
